﻿namespace Laixer.Kadaster
{
    /// <summary>
    /// Json serialiazation interface.
    /// </summary>
    public interface IJsonSerialzer
    {
        /// <summary>
        /// Serializes the specified object to a JSON string.
        /// </summary>
        /// <param name="value">The object to serialize.</param>
        /// <returns>A JSON string representation of the object.</returns>
        string SerializeObject(object value);

        /// <summary>
        /// Deserializes the JSON to the specified .NET type.
        /// </summary>
        /// <typeparam name="T">The type of the object to deserialize to.</typeparam>
        /// <param name="value">The JSON to deserialize.</param>
        /// <returns>The deserialized object from the JSON string.</returns>
        T DeserializeObject<T>(string value);
    }
}